<script lang="ts" setup>
import UserApiV1 from '@/api/userApi'
import { computed, ref } from 'vue'

// TODO Change for recieving All UserData
const props = defineProps({
  userId: {
    type: Number,
    default: -1, // store.state.user.id
  },
})

// const userId = ref(store.state.user.id);

const passwordValueNew = ref('')
const passwordValueConfirm = ref('')

const isPasswordVisible = ref(false)
const isCPasswordVisible = ref(false)

const saving = ref(false)
const isRequest = ref(false)
const valid = ref(false)
const requestMessage = ref('')
const isError = ref(false)

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error' : 'Success')

// Referencia al formulario para gestionar la validación
const form = ref(null)

// Function to validate the form and then change password
const validateAndChangePassword = async () => {
  // If Vuetify form validation is successful, proceed with password change
  if (form.value.validate())
    await changePassword()
}

// Function to perform the API call for changing the password
const changePassword = async () => {
  // Need to restart isRequest value for show again if you close it
  isRequest.value = false
  saving.value = true

  const api = new UserApiV1()
  try {
    const response = await api.createUserPassword(passwordValueNew.value, props.userId)

    console.log('responseUserData: ', JSON.parse(JSON.stringify(response.data.message)))
    requestMessage.value = response.data.message
    isError.value = false
  }
  catch (error: unknown) {
    console.error('error changePassword', error.response)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  finally {
    saving.value = false
    isRequest.value = true
  }
}
</script>

<template>
  <VForm
    ref="form"
    @validation-change="valid = $event"
  >
    <VRow>
      <!-- 👉 Message Title and subtitle -->
      <VCol cols="12">
        <h6 class="text-h6 font-weight-medium">
          Password Change
        </h6>
        <p class="mb-0">
          Enter your new password
        </p>
      </VCol>
    </VRow>

    <VRow>
      <!-- 👉 Message Title and subtitle -->
      <!-- 👉 :rules="[requiredValidator, passwordValidator]" -->
      <VCol
        cols="12"
        md="6"
      >
        <VTextField
          v-model="passwordValueNew"
          label="New Password"
          placeholder="············"
          :rules="[requiredValidator, passwordValidator]"
          :type="isPasswordVisible ? 'text' : 'password'"
          :append-inner-icon="isPasswordVisible ? 'tabler-eye-off' : 'tabler-eye'"
          outlined
          dense
          @click:append-inner="isPasswordVisible = !isPasswordVisible"
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        md="6"
      >
        <VTextField
          v-model="passwordValueConfirm"
          label="Confirm Password"
          placeholder="············"
          :rules="[requiredValidator, confirmedValidator(passwordValueNew, passwordValueConfirm)]"
          :type="isCPasswordVisible ? 'text' : 'password'"
          :append-inner-icon="isCPasswordVisible ? 'tabler-eye-off' : 'tabler-eye'"
          outlined
          dense
          @click:append-inner="isCPasswordVisible = !isCPasswordVisible"
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol cols="12">
        <VAlert
          v-if="isRequest"
          border="start"
          :border-color="alertToggleVariant"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          variant="tonal"
          dense
          closable
        >
          <VIcon left>
            mdi-information
          </VIcon>
          {{ alertToggleText }}: {{ requestMessage }}
        </VAlert>
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol cols="12">
        <VBtn
          color="primary"
          class="mt-2 mr-1"
          :disabled="valid"
          @click="validateAndChangePassword"
        >
          <VProgressCircular
            v-if="saving"
            indeterminate
            size="14"
          />
          <span v-if="saving"> Saving... </span>
          <span v-else> Save changes </span>
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped>
</style>
